//+------------------------------------------------------------------+
//|                                                          BT1.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//----------------------------------------------
//---- input parameters
extern int       EnableAlerts=0;
extern int       SignalID=0;
extern int       CountBars=500;
extern int Simbol   =119;
//---- buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
//---- 
int    shift,limit,f,p,x1,x2,value11,a1,tsig;
double value2,value3,Range,Range1,Range2,val1,val2,d,val3,s;
//----------------------------------------------
extern double sl = 50;
extern double lots = 1;   //0.01 -> 1
extern int MagicNumber = 87878;
static int prevtime = 0;

//   trailing-stop
extern double tr_st_buy = 30;//50;
extern double tr_st_sell = 30;//50;

extern double pribavlenie = 30;//50;
extern double pribavlenie1 = 30;//50;


double sell_order_open;
double buy_order_open;

//================================================
//1 
extern int     BR1TF          = 15;
extern int     BR1Bars        = 500;
extern int     ShftBR1        = 0;
//2 
extern int     BR2TF          = 15;
extern int     BR2Bars        = 500;
extern int     ShftBR2        = 0;
// TF 
extern int     BRLowTF        = 5;
extern int     BRLowBars      = 500;
extern int     ShftBRLow      = 0;
//TRStop 
extern int     BRTRStopTF    = 1;
extern int     BRTRStopBars  = 500;
extern int     ShftBRTRStop  = 0;
// 
extern int     TF2Signal     = 15;
extern int     Period2Signal = 14;
extern int     Shft0         = 0;
extern int     Shft1         = 1;



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//=========================================== 
 double BR1Bar1, BR1Bar2;
   double BR1Sig1, BR1Sig2;
   double BR1Stop1, BR1Stop2;
   double BR2Bar1, BR2Bar2;
   double BR2Sig1, BR2Sig2;
   double BR2Stop1, BR2Stop2;
   double BRLowBar1, BRLowBar2;
   double BRLowSig1, BRLowSig2;
   double BRLowStop1, BRLowStop2;
   double BRTRBar1, BRTRBar2;
   double BRTRSig1, BRTRSig2;
   double BRTRStop1, BRTRStop2;
   double ADXADXCurr, ADXADXPrev, ADXPlsCurr, ADXMnsCurr, ADXPlsPrev, ADXMnsPrev;
   double TP, SL;
   int    TradeType, RealTotal, total2, cnt, iModFlag; 
  
//==========================================  
  sell_order_open = 0;  
  buy_order_open = 0;

  int ticket = -1;
//===========================================
  // check for opened position
   int total = OrdersTotal();   
//----
   for(int i = total - 1; i >= 0; i--) 
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       // check for symbol & magic number
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {
           int prevticket = OrderTicket();
           // long position is opened
           if(OrderType() == OP_BUY) 
             {
               // check profit 
                                                                                      
               if  (  (iCustom(NULL,0,"BrainTrend2SigN",CountBars    ,1,0)!=EMPTY_VALUE) && (iCustom(NULL,0,"BrainTrend1SigN",CountBars    ,1,0)!=EMPTY_VALUE)  )   //1            
                 {               
                   if (  (iCustom(NULL,0,"BrainTrend2SigN",CountBars    ,1,0)!=EMPTY_VALUE) && (iCustom(NULL,0,"BrainTrend1SigN",CountBars    ,1,0)!=EMPTY_VALUE)   )   //1             
                     { 
                           PlaySound("Close.wav");
                     
                           OrderClose(OrderTicket(), lots, Bid, 2,  Green);
                           buy_order_open = 0;
                         //  tr_st_buy = pribavlenie;//35;   -   
                     } 
                     
                   else 
                     { 
                    
                     }
                              
                 }  
               
  //========================================================================                   
         

//========================================================================                             
               
               // short position is opened
             } 
            
           else 
             {
               // check profit 
               
               if ( (iCustom(NULL,0,"BrainTrend2SigN",CountBars    ,0,0)!=EMPTY_VALUE) && (iCustom(NULL,0,"BrainTrend1SigN",CountBars    ,0,0)!=EMPTY_VALUE)      )            
                 {
                   if ( (iCustom(NULL,0,"BrainTrend2SigN",CountBars    ,0,0)!=EMPTY_VALUE) && (iCustom(NULL,0,"BrainTrend1SigN",CountBars    ,0,0)!=EMPTY_VALUE)     )                  
                     {
                         PlaySound("Close.wav");
                         
                         OrderClose(OrderTicket(), lots, Ask, 2,  Green);    
                         sell_order_open = 0;
                  //       tr_st_sell = pribavlenie1;    -   
                     } 
                   else 
                     { 
                    
                     }    
                               
 //=================================================================                
                 }  
   
            
            
            
             }

         }
     }
//     ==========================
// check for long or short position possibility
   
   BR1Bar1  = iCustom(NULL, BR1TF, "BrainTrend1N", BR1Bars, 0, ShftBR1);
   BR1Bar2  = iCustom(NULL, BR1TF, "BrainTrend1N", BR1Bars, 1, ShftBR1);
   BR1Sig1  = iCustom(NULL, BR1TF, "BrainTrend1SigN", BR1Bars,  0, ShftBR1);//0, 0,
   BR1Sig2  = iCustom(NULL, BR1TF, "BrainTrend1SigN", BR1Bars,  1, ShftBR1);//0, 0,
   BR1Stop1 = iCustom(NULL, BR1TF, "BrainTrend1StopN", BR1Bars,  0, ShftBR1);//0, 0,
   BR1Stop2 = iCustom(NULL, BR1TF, "BrainTrend1StopN", BR1Bars,  1, ShftBR1);//0, 0,
   
   BR2Bar1  = iCustom(NULL, BR2TF, "BrainTrend2N", BR2Bars, 0, ShftBR2);
   BR2Bar2  = iCustom(NULL, BR2TF, "BrainTrend2N", BR2Bars, 1, ShftBR2);
   BR2Sig1  = iCustom(NULL, BR2TF, "BrainTrend2SigN", BR2Bars, 0, 0, 0, ShftBR2);
   BR2Sig2  = iCustom(NULL, BR2TF, "BrainTrend2SigN", BR2Bars, 0, 0, 1, ShftBR2);
   BR2Stop1 = iCustom(NULL, BR2TF, "BrainTrend2StopN", BR2Bars, 0, 0, 0, ShftBR2);
   BR2Stop2 = iCustom(NULL, BR2TF, "BrainTrend2StopN", BR2Bars, 0, 0, 1, ShftBR2);
  
//================================================   
   if ( (iCustom(NULL,0,"BrainTrend2SigN",CountBars    ,0,0)!=EMPTY_VALUE) && (iCustom(NULL,0,"BrainTrend1SigN",CountBars    ,0,0)!=EMPTY_VALUE  )&& (BT1StopLine()==1)    ) // 
     { 
         Alert("Buy signal", "  ",iCustom(NULL,0,"BrainTrend1StopN",Simbol,CountBars,EnableAlerts,SignalID,   1,0),"   ", iCustom(NULL,0,"BrainTrend1StopN",Simbol,CountBars,EnableAlerts,SignalID,   0,0) );
         
            if ( OrdersTotal()==0 )//buy_order_open==0 
         {
    
         PlaySound("Buy_sound.wav");  
         
   
              //long
                ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Bid - sl * Point, 0, "Buy", MagicNumber, 0, Blue); 
              //----
                     if(ticket < 0) 
                      {
                        Sleep(30000);
                        prevtime = Time[1];
                      }   
                   
            buy_order_open = 1;
         }
   
     } 
//=============================================== 

 
   if (  (iCustom(NULL,0,"BrainTrend2SigN",CountBars,    1,0)!=EMPTY_VALUE) && (iCustom(NULL,0,"BrainTrend1SigN",CountBars,    1,0)!=EMPTY_VALUE)       ) //     
     { 
     Alert("Sell signal",   "  ",iCustom(NULL,0,"BrainTrend2StopN",Simbol,CountBars,   1,0),"   ", iCustom(NULL,0,"BrainTrend2StopN",Simbol,CountBars,   0,0));
 //--------------------------------------------------         
            if ( OrdersTotal()==0 )    //sell_order_open==0
        {
   
   
            PlaySound("Sell_sound.wav");  
 
            // short
               ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Ask + sl * Point, 0, "Sell", MagicNumber, 0, Red);  
               if(ticket < 0) 
                {
                     Sleep(30000);
                     prevtime = Time[1];
                }
                
            sell_order_open = 1;
         }
//===============================================                  
                
     }


//===============================================
   return(0);


}

//============================================================
//  

int BT1StopLine() 
{
   if (  (iCustom(NULL,0,"BrainTrend2StopN",Simbol, CountBars,   1,0)!=0)&&(iCustom(NULL,0,"BrainTrend2StopN",Simbol, CountBars,  1,0)<Open[0] )    )
   {
   return(1);
   
   }


return(0);
}


